/**
 * Copyright jmbyh521 ( http://wonderfl.net/user/jmbyh521 )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/CkpT
 */

// forked from Hakuhin's Pixel Bender (円状にサインカーブで波打つフィルタ)
// -------------------------------------------------
//
// 円状にサインカーブで波打つフィルタ
// 
//　
//　中心から垂直に捻ってます。
//
// -------------------------------------------------
package {
    import flash.events.*;
    import flash.display.*;
    import flash.net.*;
    import flash.text.*;
    import flash.utils.*;
    import flash.system.*;
    import flash.geom.*;
    import flash.filters.*;
    import flash.ui.*;
     import net.hires.debug.Stats;
    public class Main extends Sprite {
        public function Main() {



// -------------------------------------------------
// コンストラクタ
// -------------------------------------------------

// フレームレート       
stage.frameRate = 60;

// 100%表示
stage.scaleMode = StageScaleMode.NO_SCALE;

// 左上
stage.align = StageAlign.TOP_LEFT;
stage.align = "TL";

// スプライトを配置
var board : Sprite = new Sprite();
addChild(board);

// リソース読み込み開始
load();


// -------------------------------------------------
// 読み込み
// -------------------------------------------------
function load():void{

    // 画像のURL
    var graphic_url:String = "https://upload.wikimedia.org/wikipedia/commons/thumb/9/97/Emerald_Bay.jpg/1280px-Emerald_Bay.jpg";

    // ローダー
    var loader_obj : Loader = new Loader();
    
    // 読み込み開始
    var url : URLRequest = new URLRequest(graphic_url);
    loader_obj.load(url);
    
    // 読み込み終了
    var info : LoaderInfo = loader_obj.contentLoaderInfo;
    info.addEventListener (Event.INIT,LoaderInfoInitFunc);
    function LoaderInfoInitFunc (event : Event):void {

        // 読み込んだ画像を表示
        board.addChild(loader_obj);

        // 初期化へ
        init();
    }
}


// -------------------------------------------------
// 初期化
// -------------------------------------------------
function init():void{

    // ステージサイズ
    var w:uint;
    var h:uint;    
    
    // リサイズ時にフィット
    stage.addEventListener(Event.RESIZE,ResizeFunc);
    function ResizeFunc(e:Event):void{
        w = stage.stageWidth;
        h = stage.stageHeight;
        board.width = w;
        board.height = h;
    }
    ResizeFunc(null);
    
    // シェーダバイトコード
    var binary : ByteArray = CustomFilterGetByteArray();
    
    // シェーダ作成
    var shader:Shader = new Shader();
    shader.byteCode = binary;
    var filter:ShaderFilter = new ShaderFilter(shader); 

    // パラメータアクセス用
    var data : ShaderData  = shader.data;
    var param : ShaderParameter;

    // パラメータ
    var phase:Number = 0;        // 位相
    var amplitude:Number = 10;    // 振幅
    var cycle:Number = 100;        // 周期

    addEventListener(Event.ENTER_FRAME,function(e:Event):void{
        
        // 位相を変化
        phase += 0.01;
        if(phase > 1)    phase -= 1;

        // 位置
        param = data.position;
        param.value = [mouseX,mouseY];                    

        // 位相
        param = data.phase;
        param.value = [phase];

        // 振幅
        param = data.amplitude;
        param.value = [amplitude];

        // 周期
        param = data.cycle;
        param.value = [cycle];

        // 適応
        board.filters = [filter];
    });
    
    // テキスト表示
    var tf : TextField = new TextField();
    tf.x = 5;
    tf.y = 5;
    tf.width = 200;
    tf.height = 40;
    tf.border = true;
    tf.background = true;
    addChild(tf);
    addEventListener(Event.ENTER_FRAME,function(e:Event):void{
        var str:String = "";
        str += "振幅:" + amplitude + "　(上下キーで変更)\n";
        str += "周期:" + cycle + "　(左右キーで変更)\n";
        
        tf.text = str;
    });
    
    
    // キー操作
    stage.addEventListener(KeyboardEvent.KEY_DOWN, KeyDown);
    function KeyDown(event:KeyboardEvent):void{
        if(event.keyCode == Keyboard.UP)        amplitude -= 1;
        if(event.keyCode == Keyboard.DOWN)    amplitude += 1;
        if(event.keyCode == Keyboard.LEFT)    cycle -= 10;
        if(event.keyCode == Keyboard.RIGHT)    cycle += 10;
        
        if(amplitude < 0)    amplitude = 0;
        if(cycle < 0)    cycle = 0;
    };

}


// -------------------------------------------------
// シェーダバイトコード
// -------------------------------------------------
function CustomFilterGetByteArray():ByteArray{

    var a:ByteArray = new ByteArray();
    var f:Function;

    f = a.writeUnsignedInt;
    f(0xa5010000); f(0x00a41600); f(0x43697263); f(0x6c655761); 
    f(0x76654369); f(0x72636c65); f(0x46696c74); f(0x6572a00c); 
    f(0x6e616d65); f(0x73706163); f(0x65006375); f(0x72766520); 
    f(0x77617665); f(0x20636972); f(0x636c6500); f(0xa00c7665); 
    f(0x6e646f72); f(0x0048616b); f(0x7568696e); f(0x00a00876); 
    f(0x65727369); f(0x6f6e0001); f(0x00a00c64); f(0x65736372); 
    f(0x69707469); f(0x6f6e0089); f(0x7e8ff382); f(0xc9835483); 
    f(0x43839383); f(0x4a815b83); f(0x7582c594); f(0x6791c582); 
    f(0xc2837483); f(0x42838b83); f(0x5e00a101); f(0x0200000c); 
    f(0x5f4f7574); f(0x436f6f72); f(0x6400a300); f(0x04737263); 
    f(0x00a10204); f(0x01000f64); f(0x737400a1); f(0x01020000); 
    f(0x03706f73); f(0x6974696f); f(0x6e00a202); f(0x64656661); 
    f(0x756c7456); f(0x616c7565); f(0x00000000); f(0x00000000); 
    f(0x00a20c64); f(0x65736372); f(0x69707469); f(0x6f6e0089); 
    f(0x7e82cc92); f(0x8690538d); f(0xc0955700); f(0xa1010102); 
    f(0x00086379); f(0x636c6500); f(0xa2016d69); f(0x6e56616c); 
    f(0x7565003f); f(0x800000a2); f(0x01646566); f(0x61756c74); 
    f(0x56616c75); f(0x650042c8); f(0x0000a20c); f(0x64657363); 
    f(0x72697074); f(0x696f6e00); f(0x946782aa); f(0x88ea8efc); 
    f(0x82b782e9); f(0x92b782b3); f(0x00a10101); f(0x02000470); 
    f(0x68617365); f(0x00a2016d); f(0x696e5661); f(0x6c756500); 
    f(0x00000000); f(0xa2016d61); f(0x7856616c); f(0x7565003f); 
    f(0x800000a2); f(0x01646566); f(0x61756c74); f(0x56616c75); 
    f(0x65000000); f(0x0000a20c); f(0x64657363); f(0x72697074); 
    f(0x696f6e00); f(0x946782cc); f(0x88ca918a); f(0x00a10101); 
    f(0x02000261); f(0x6d706c69); f(0x74756465); f(0x00a2016d); 
    f(0x696e5661); f(0x6c756500); f(0x00000000); f(0xa2016465); 
    f(0x6661756c); f(0x7456616c); f(0x75650041); f(0x200000a2); 
    f(0x0c646573); f(0x63726970); f(0x74696f6e); f(0x00946782); 
    f(0xcc976882); f(0xea959d00); f(0x1d0300c1); f(0x00001000); 
    f(0x1d020010); f(0x00008000); f(0x02020010); f(0x03000000); 
    f(0x1d030020); f(0x0200c000); f(0x1d020010); f(0x0000c000); 
    f(0x02020010); f(0x03004000); f(0x1d030010); f(0x0200c000); 
    f(0x1d0400c1); f(0x0300b000); f(0x1d020010); f(0x04004000); 
    f(0x06020010); f(0x04000000); f(0x1d030020); f(0x0200c000); 
    f(0x1d020010); f(0x04000000); f(0x03020010); f(0x04000000); 
    f(0x1d030010); f(0x04004000); f(0x03030010); f(0x04004000); 
    f(0x1d040020); f(0x0200c000); f(0x01040020); f(0x0300c000); 
    f(0x16020010); f(0x04008000); f(0x1d030010); f(0x0200c000); 
    f(0x04020010); f(0x02000000); f(0x03020010); f(0x0300c000); 
    f(0x1d040020); f(0x0200c000); f(0x1a020010); f(0x04008000); 
    f(0x1d040010); f(0x04008000); f(0x02040010); f(0x0200c000); 
    f(0x1d040020); f(0x0400c000); f(0x32020010); f(0x42b40000); 
    f(0x01030020); f(0x0200c000); f(0x1d020010); f(0x04008000); 
    f(0x01020010); f(0x02004000); f(0x32040010); f(0x43b40000); 
    f(0x1d050080); f(0x0200c000); f(0x03050080); f(0x0400c000); 
    f(0x32020010); f(0x3c8efa35); f(0x03020010); f(0x05000000); 
    f(0x0c040010); f(0x0200c000); f(0x1d020010); f(0x0400c000); 
    f(0x03020010); f(0x02008000); f(0x1d030010); f(0x0200c000); 
    f(0x0d020010); f(0x03008000); f(0x1d040010); f(0x0200c000); 
    f(0x03040010); f(0x0300c000); f(0x01030080); f(0x0400c000); 
    f(0x0c020010); f(0x03008000); f(0x1d040010); f(0x0200c000); 
    f(0x03040010); f(0x0300c000); f(0x01030040); f(0x0400c000); 
    f(0x310500f1); f(0x03001000); f(0x1d0100f3); f(0x05001b00); 
    
    return a;
}

            
        }
    }
}


// ↓ pbk ファイルのコード
/* -----------------------------------------------------------------------------
    パラメータ
    position        円の中心座標
    cycle            波が一周する長さ
    phase            波の位相 ( 0 ～ 1 までゆっくり変化させる)
    amplitude        波の揺れ幅
 ----------------------------------------------------------------------------- */
/*
<languageVersion : 1.0;>
kernel CircleWaveCircleFilter<
    namespace : "curve wave circle";
    vendor : "Hakuhin";
    version : 1;
    description : "円状にサインカーブで波打つフィルタ";
>{
    input image4 src;    // 入力イメージ
    output pixel4 dst;    // 出力ピクセル


    // -------------------------------------
    // パラメータ
    // -------------------------------------
    parameter float2 position<
        defaultValue:float2(0.0 , 0.0);
        description : "円の中心座標";
    >;
    parameter float cycle<
        minValue:float(1.0);
        defaultValue:float(100.0);
        description : "波が一周する長さ";
    >;
    parameter float phase<
        minValue:float(0.0);
        maxValue:float(1.0);
        defaultValue:float(0);
        description : "波の位相";
    >;
    parameter float amplitude<
        minValue:float(0.0);
        defaultValue:float(10.0);
        description : "波の揺れ幅";
    >;


    // -------------------------------------
    // ピクセルごとに実行される関数
    // -------------------------------------
    void evaluatePixel(){
        // ピクセルの位置を取得
        float2 pos = outCoord();

        // 位置から中心座標までのベクトルを取得
        float2 v = float2(position.x - pos.x,position.y - pos.y);

        // ベクトルからラジアンを取得
        float rad = atan(v.y , v.x);

        // ベクトルから長さを求める
        float distance = sqrt((v.x * v.x) + (v.y * v.y));
        
        // 周期に丸める
        float d = distance / cycle;
        d = d - floor(d);
        
        // オフセットを取得して座標に加算
        rad += 90.0;
        distance = sin(radians((d + phase) * 360.0)) * amplitude;
        pos.x += cos(rad) * distance;
        pos.y += sin(rad) * distance;

        // ソースイメージからピクセルカラーを取得して出力
        dst = sampleLinear(src,pos);
    }
}
*/




// -------------------------------------------------
// 外部画像をサムネイルとしてキャプチャ
// -------------------------------------------------
import flash.net.*;
import flash.events.*;
import flash.display.*;
import flash.geom.*;
function ThumbnailCapture(url:String,time:uint,stage:Stage):void{

    // キャプチャタイミング
    Wonderfl.capture_delay( time );

    
    // スプライト作成
    var sprite : Sprite = new Sprite();

    // ステージ最前面に配置
    stage.addChildAt(sprite,stage.numChildren);
    
    // ローダー
    var loader_obj : Loader = new Loader();
    loader_obj.contentLoaderInfo.addEventListener (Event.INIT,function(e:Event):void{

        // メモリからインスタンス化
        var loader_memory : Loader = new Loader();
        loader_memory.contentLoaderInfo.addEventListener (Event.INIT,function(e:Event):void{

            // キャプチャ
            var bmp : BitmapData = new BitmapData(loader_memory.width,loader_memory.height,true,0);
            sprite.addChild(loader_memory);
            bmp.draw(sprite);
            sprite.removeChild(loader_memory);
            loader_memory.unload();
            loader_obj.unload();
            loader_memory = null;
            loader_obj = null;
            
            
            // 画像を配置
            var bmp_obj : Bitmap = new Bitmap(bmp);
            bmp_obj .width = stage.stageWidth;
            bmp_obj .height = stage.stageHeight;
            stage.addChild(bmp_obj );
            
        });
        
        // 読み込み開始
        loader_memory.loadBytes(loader_obj.contentLoaderInfo.bytes);
    });
    
    // 読み込み開始
    loader_obj.load(new URLRequest(url));
}